-- author: DD ModPassion
-- date: 22.11.2021
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: Farming Simulator 22
SowingMachineAddon = {} function SowingMachineAddon.initSpecialization() local schema = Vehicle.xmlSchema schema:setXMLSpecializationType("SowingMachine") schema:register(XMLValueType.BOOL, "vehicle.sowingMachine#changeSeed", "Change seed") schema:setXMLSpecializationType() end function SowingMachineAddon.prerequisitesPresent(specializations) return SpecializationUtil.hasSpecialization(SowingMachine, specializations) end function SowingMachineAddon.registerOverwrittenFunctions(vehicleType) SpecializationUtil.registerOverwrittenFunction(vehicleType, "getIsSeedChangeAllowed", SowingMachineAddon.getIsSeedChangeAllowed) SpecializationUtil.registerOverwrittenFunction(vehicleType, "unloadFillUnits", SowingMachineAddon.unloadFillUnits) SpecializationUtil.registerOverwrittenFunction(vehicleType, "setFillUnitForcedMaterialFillType", SowingMachineAddon.setFillUnitForcedMaterialFillType) end function SowingMachineAddon.registerEventListeners(vehicleType) SpecializationUtil.registerEventListener(vehicleType, "onLoad", SowingMachineAddon) end function SowingMachineAddon:onLoad(savegame) local spec = self.spec_sowingMachine spec.isInitialized = true if self.xmlFile:getValue("vehicle.sowingMachine#changeSeed") == nil then spec.isInitialized = false end local fillUnitConfigurationId = Utils.getNoNil(self.configurations.fillUnit, 1) local baseKey = string.format("vehicle.fillUnit.fillUnitConfigurations.fillUnitConfiguration(%d).fillUnits", fillUnitConfigurationId - 1) local fruitTypeNames = self.xmlFile:getValue(baseKey..".fillUnit(0)#fillTypes") spec.fillTypeIndex = g_fillTypeManager:getFillTypeIndexByName(fruitTypeNames:sub(1, -7)) self:setSeedIndex(fillUnitConfigurationId) end function SowingMachineAddon:getIsSeedChangeAllowed(superfunc) local spec = self.spec_sowingMachine if spec.isInitialized then return false else return self.spec_sowingMachine.allowsSeedChanging end end function SowingMachineAddon:setFillUnitForcedMaterialFillType(superfunc, fillUnitIndex, forcedMaterialFillType) local spec = self.spec_fillUnit if forcedMaterialFillType == FillType.SEEDS then forcedMaterialFillType = next(spec.fillUnits[fillUnitIndex].supportedFillTypes) if spec.fillUnits[fillUnitIndex] ~= nil then spec.fillUnits[fillUnitIndex].forcedMaterialFillType = forcedMaterialFillType end self:setFillPlaneForcedFillType(fillUnitIndex, forcedMaterialFillType) if self.setFillVolumeForcedFillTypeByFillUnitIndex ~= nil then self:setFillVolumeForcedFillTypeByFillUnitIndex(fillUnitIndex, forcedMaterialFillType) end end end function SowingMachineAddon:unloadFillUnits(superfunc, ignoreWarning) if not self.isServer then g_client:getServerConnection():sendEvent(FillUnitUnloadEvent.new(self)) else local spec = self.spec_fillUnit if spec.unloadingFillUnitsRunning then return end local unloadingPlaces = spec.unloading local places = {} for _, unloading in ipairs(unloadingPlaces) do local node = unloading.node local ox, oy, oz = unpack(unloading.offset) local x, y, z = localToWorld(node, ox - unloading.width * 0.5, oy, oz) local place = { startZ = z, startY = y, startX = x } place.rotX, place.rotY, place.rotZ = getWorldRotation(node) place.dirX, place.dirY, place.dirZ = localDirectionToWorld(node, 1, 0, 0) place.dirPerpX, place.dirPerpY, place.dirPerpZ = localDirectionToWorld(node, 0, 0, 1) place.yOffset = 1 place.maxWidth = math.huge place.maxLength = math.huge place.maxHeight = math.huge place.width = unloading.width table.insert(places, place) end local usedPlaces = {} local success = true local availablePallets = {} local unloadingTasks = {} for k, fillUnit in ipairs(self:getFillUnits()) do local fillLevel = self:getFillUnitFillLevel(k) local fillTypeIndex = self:getFillUnitFillType(k) if self:getFillUnitAllowsFillType(k, FillType.SEEDS) then fillTypeIndex = self.spec_sowingMachine.fillTypeIndex end local fillType = g_fillTypeManager:getFillTypeByIndex(fillTypeIndex) if fillUnit.canBeUnloaded and fillLevel > 0 and fillType.palletFilename ~= nil then table.insert(unloadingTasks, { fillUnitIndex = k, fillTypeIndex = fillTypeIndex, fillLevel = fillLevel, filename = fillType.palletFilename }) end end local function unloadNext() local task = unloadingTasks[1] if task ~= nil then for pallet, _ in pairs(availablePallets) do local fillUnitIndex = pallet:getFirstValidFillUnitToFill(task.fillTypeIndex) if fillUnitIndex ~= nil then local appliedDelta = pallet:addFillUnitFillLevel(self:getOwnerFarmId(), fillUnitIndex, task.fillLevel, task.fillTypeIndex, ToolType.UNDEFINED, nil) self:addFillUnitFillLevel(self:getOwnerFarmId(), task.fillUnitIndex, -appliedDelta, task.fillTypeIndex, ToolType.UNDEFINED, nil) task.fillLevel = task.fillLevel - appliedDelta if pallet:getFillUnitFreeCapacity(fillUnitIndex) <= 0 then availablePallets[pallet] = nil end end end if task.fillLevel > 0 then local function asyncCallback(_, vehicle, vehicleLoadState, arguments) if vehicleLoadState == VehicleLoadingUtil.VEHICLE_LOAD_OK then vehicle:emptyAllFillUnits(true) availablePallets[vehicle] = true unloadNext() end end local size = StoreItemUtil.getSizeValues(task.filename, "vehicle", 0, {}) local x, y, z, place, width, _ = PlacementUtil.getPlace(places, size, usedPlaces, true, true, true) if x == nil then success = false if (ignoreWarning == nil or not ignoreWarning) and not success then g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_INFO, spec.texts.unloadNoSpace) end return end PlacementUtil.markPlaceUsed(usedPlaces, place, width) local location = { x = x, y = y, z = z, yRot = place.rotY } VehicleLoadingUtil.loadVehicle(task.filename, location, true, 0, Vehicle.PROPERTY_STATE_OWNED, self:getOwnerFarmId(), nil, nil, asyncCallback, nil) else table.remove(unloadingTasks, 1) unloadNext() end end end unloadNext() end end